Page MenuHomePhabricator

A user who is bi-lingual / trilingual can easily switch article language and favorite languages
Closed, DuplicatePublic5 Story Points

Description

As a multi-lingual user I want to be able to change article languages quickly.

Acceptance criteria

  • Add language icon to toolbar
  • List is shown as "Language name" (in native language) and below "Article title" (in native language)
  • Initial number of links are shortened when the list is longer than 6 items. If that happens, only 3 items are shown initially.
  • The initial languages are decided based on the previous user selections (stored on a cookie), browser language info, and geo-ip information
  • If there are more than 20 languages, organize the list by region. Include "Common languages" and "Worldwide" before regions
  • Region titles are shown in the current language

Implementation on desktop
https://www.mediawiki.org/wiki/Universal_Language_Selector/Design/Interlanguage_links

Prototype
http://invis.io/5R2WGRGXM

Design
Languages

More

Event Timeline

KLans_WMF created this task.May 1 2015, 6:26 PM
KLans_WMF raised the priority of this task from to Needs Triage.
KLans_WMF updated the task description. (Show Details)
KLans_WMF moved this task to To Do on the Mobile-App-Sprint-57-iOS board.
KLans_WMF added a subscriber: KLans_WMF.
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptMay 1 2015, 6:26 PM
KLans_WMF set Security to None.
KLans_WMF added a subscriber: KHammerstein.
Vibhabamba edited subscribers, added: Vibhabamba; removed: KHammerstein.

@Amire80 This feature is slotted for next sprint for both iOS and Android.

  • do we already have a service for identifying top likely languages for user/article?

Nothing very convenient. Extension:UniversalLanguageSelector (ULS) does it for Common Languages in general and for the Compact Language Links beta feature in particular. For a while I wanted to convert this functionality into a more portable service or library, but it hasn't happened yet. If the mobile web team's fine engineers can get around to making it more reusable, we shall be eternally grateful. Actually, the ULS extension has some groundwork for mobile support, although AFAIK it was never truly used anywhere.

In particular, check the following files:

If these pointers are too brief or cryptic, please do ask me for more details :)

I don't know exactly what info is available to mobile browsers, but I imagine that the useful info would be:

  • Previously browsed editions of Wikipedia
  • Previously selected languages
  • The device's UI language
  • Geolocation
  • On cellular connections, the carrier's country (I'm not sure at all that it's available)
  • The browser's UI language
  • The request's Accept-Language

Also, please do play with the Compact Language Links beta feature on the desktop.

Another thing you may find useful (and yes, I know I'm pitching it everywhere): https://www.mediawiki.org/wiki/Interlanguage_links/Implementation_comparison

One last thing: I am sure that making interlanguage links more discoverable on all platforms is important and useful, but we love to measure impact precisely, so see T78351.

Maybe @Pginer-WMF or @santhosh will have more to add.

bearND added a subscriber: bearND.May 7 2015, 1:32 PM

Does "Access from current menu" mean from the More menu?

Yes - It means More menu in the top right hand of the page.

I updated the acceptance criteria.

bearND added a comment.May 7 2015, 7:52 PM

That's called the overflow menu.

I hope you mean the overflow menu from the search fragment, though, since it should be available directly from the search interface.

Please also take a look at the previous tasks related to this, which have been closed prematurely: T87154 and T73136. (I think one person closed one task as duplicate of the other one, then another did the same but in the opposite way.) They already contain a good explanation what pain point we're supposed to solve, and some great ideas on how to fast switch languages.
When I look at the description of this task it seems to try to address finding the language in the language picker dialog. While that is a nice to have thing it's not as important as being able to quickly open the language picker. We already sort the languages by most recently used and most popular language. We also already have a filter EditText field to quickly search by language name.

bearND added a comment.May 8 2015, 4:57 PM

After looking at the prototype and reading the updates to the description I've got a few more questions:

Add language icon to toolbar

  • Is this just for "Read [this article] in other languages"? Do you just want us to rename this menu entry? How is the new title better? BTW, there is no icon needed. Just text.
  • What about search language (which we currently have in the More menu)? This is the most important part.

If there are more than 20 languages, organize the list by region. Include "Common languages" and "Worldwide" before regions

  • What's the difference between "Common languages" and "Worldwide" languages? Does world wide mean the rest? But then there's also regions. That seems confusing. Why do we need to put the languages into buckets?

The initial languages are decided based on the previous user selections (stored on a cookie), browser language info, and geo-ip information

  • We don't store that in cookies but in a SharedPreference.
  • I'd prefer to avoid requesting the user's current location. Since that costs battery, and we currently tell users that we only request location data for the nearby feature. I'd be ok with using the most recently requested location from the Nearby functionality.

"Region titles are shown in the current language"

It would be easier to just show it in the device language.

@bearND @Pginer-WMF
What about search language (which we currently have in the More menu)? This is the most important part.

I believe search is in the more section to really simplify the first page, so that if one of the first selections is what the user is looking for, they can very quickly select that, and not be distracted by anything else. In user tests it looks like some users preferred to search, and some preferred to browse.
Also note, the wikiwand app and desktop has a very similar experience.

What's the difference between "Common languages" and "Worldwide" languages? Does world wide mean the rest? But then there's also regions. That seems confusing. Why do we need to put the languages into buckets?

@Pginer-WMF can answer more of this. I think the reason to put languages into buckets is to help break up a very long list into something more easy to browse.

bearND added a comment.May 8 2015, 7:30 PM

Interesting info from @KHammerstein via IRC:
Here's the link to the initial project https://www.mediawiki.org/wiki/Universal_Language_Selector/Design/Interlanguage_links
This is the compact language links built by the language engineering team (probably @santhosh).
Its a beta feature on desktop.

@santhosh: Where can I find the desktop code that puts the languages into various buckets? Is there an API for that?

@Dbrant is tentatively calling this 5 story points, pending more design input.

KLans_WMF edited a custom field.May 25 2015, 12:02 PM

@Dbrant will sync up with @KHammerstein on remaining design questions

@Dbrant What remaining design questions are there?

Dbrant added a comment.Jun 5 2015, 2:09 AM

@KHammerstein Sorry, I was a little confused by what this task is actually about. Our highest priority is to improve the way the user selects languages when searching. Since we don't yet have full inter-wiki search functionality, the user has to change the Wiki language through the "More" menu every time they want to search in a different language. So, it would be great if we could give the user a tiny drop-down selection inline with the Search bar for quickly switching languages for searching.

As for reading the current article in a different language, I think our current UX is pretty sufficient (in fact, we already show the most-recently selected languages at the top). The acceptance criteria as stated in this task would take a significant amount of work, with only a marginal improvement in UX...

@KHammerstein see https://phabricator.wikimedia.org/T73136 for a description of language switching when searching

Since we don't yet have full inter-wiki search functionality

That's just a matter of interface though. CirrusSearch provides such a feature in the backend, see T46420.

@Dbrant, this seems user facing. Can it be moved to product backlog?

Niedzielski removed KHammerstein as the assignee of this task.Jan 23 2017, 9:04 PM
Niedzielski added a subscriber: KHammerstein.
RHo added a subscriber: RHo.

Most of this task has been completed (switching to another language an article is available in), and the part about switching between languages during search is addressed in the task T190839 in which this has been merged.